<template>
  <q-page class="owlie" >
        <q-toolbar class="bg row justify-end">
      <q-btn
      size="lg"
      round
      class="btn-add"
      icon="add"
      v-if="!this.viewAdd"
      @click="showAdd"
    />
        <q-toolbar-title class="text-white text-bold q-my-sm" v-if="!this.viewAdd">
          Todowliest
        </q-toolbar-title>
        <q-input filled
        v-if="this.viewAdd"
        v-model="toDo"
        class="text-owlies addelement"
        :label="$t('addElement')">
        <template v-slot:append>
          <q-btn
            size="md"
            round
            class="btn-add-include"
            icon="add"
            @click="addTodo"/>
      </template>
        </q-input>
      </q-toolbar>
      <div class="row justify-end q-ma-md" >
      <q-list bordered class="rounded-borders col-10" v-if="this.toDolist.length">
      <q-expansion-item switch-toggle-side class="expansion-todo text-grey-7 bg-grey-3 text-subtitle1" v-for="todo in this.toDolist" :key="todo.title">
        <template v-slot:header>
          <q-item-section>
            {{todo.title}}
          </q-item-section>
          <q-item-section side>
              <q-checkbox class="bg-checkbox-secondary" v-model="todo.done" @input="()=>checkDo(todo)" />
          </q-item-section>
        </template>
        <q-card>
          <q-card-section>
            <p @click="showInput" v-if="!activeInput" class="text-wrap">{{todo.description == "" ? $t('inputDescription') : todo.description}}</p>
            <q-input
              class="input-detail"
              autofocus
              v-if="activeInput"
              v-model="todo.description"
              filled
              type="textarea"
              @change="changeTodo"
            />
          </q-card-section>
        </q-card>
      </q-expansion-item>
      </q-list>
      <p class="text-subtitle1 text-grey-7 text-center q-ma-md" v-if="!this.toDolist.length">{{$t('noneTodo')}}</p>
      </div>
  </q-page>
</template>

<script>
import { ref, watch } from '@vue/composition-api';

export default {
  // name: 'PageName',
  setup(props, ctx) {
    const store = ctx.root.$store;
    const activeInput = ref(false);
    const viewAdd = ref(false);
    const toDo = ref('');
    const toDolist = ref(store.state.todo.todos);
    watch(() => store.state.todo.todos.length, () => {
      toDolist.value = store.state.todo.todos;
    }, { lazy: true, immediate: true });
    const showAdd = () => {
      viewAdd.value = !viewAdd.value;
    };
    const showInput = () => {
      activeInput.value = !activeInput.value;
    };
    const changeTodo = () => {
      store.dispatch('todo/changeTodo', toDolist.value);
      activeInput.value = !activeInput.value;
    };
    const addTodo = async () => {
      if (toDo.value) {
        await store.dispatch('todo/addTodo', {
          title: toDo.value, createdAt: Date.now(), done: false, description: '',
        });
        store.commit('todo/setTodoswithFB');
        toDo.value = '';
      }
      viewAdd.value = !viewAdd.value;
    };
    const checkDo = async (todo) => {
      await store.dispatch('todo/deleteTodo', todo);
      store.commit('todo/setTodoswithFB');
    };
    return {
      activeInput,
      viewAdd,
      toDo,
      toDolist,
      showAdd,
      addTodo,
      checkDo,
      showInput,
      changeTodo,
    };
  },
};
</script>
